'''
MIT License

Copyright (c) 2023 Ulster University (https://www.ulster.ac.uk).
Project: Harmony (https://harmonydata.ac.uk)
Maintainer: Thomas Wood (https://fastdatascience.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

'''

from harmony.schemas.requests.text import Instrument

'''
The master copy of the examples is in the Harmony API repo.
To update this list from the JSON file in the API, go to the API repo and run:
sed "s/\bnull\b/None/g" example_questionnaires.json | sed '$!s/$/,/' >> ../harmony/src/harmony/examples.py
'''

example_instruments = dict([(i["instrument_name"], Instrument.model_validate(i)) for i in [
{"file_id": "83a12170a5a74809885affc0c381dd41", "instrument_id": "b45b7169e711414582768b8c8431027c", "instrument_name": "CES_D English", "file_name": "CES_D English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "I was bothered by things that usually don’t bother me.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "I did not feel like eating; my appetite was poor.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "I felt that I could not shake off the blues even with help from my family or friends.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "I felt I was just as good as other people.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "I had trouble keeping my mind on what I was doing.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "I felt depressed.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "I felt that everything I did was an effort.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "I felt hopeful about the future.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "I thought my life had been a failure.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "I felt fearful.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "My sleep was restless.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "I was happy.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "13", "question_intro": None, "question_text": "I talked less than usual.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "14", "question_intro": None, "question_text": "I felt lonely.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "15", "question_intro": None, "question_text": "People were unfriendly.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "16", "question_intro": None, "question_text": "I enjoyed life.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "17", "question_intro": None, "question_text": "I had crying spells.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "18", "question_intro": None, "question_text": "I felt sad.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "19", "question_intro": None, "question_text": "I felt that people dislike me.", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "20", "question_intro": None, "question_text": "I could not get “going.”", "options": ["Rarely or none of the time (less than 1 day)", "Some or a little of the time (1-2 days)", "Occasionally or a moderate amount of time (3-4 days)", "Most or all of the time (5-7 days)"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "614b672c9dfb41c386fbbd4e44ff38b4", "instrument_id": "65c0c54c3f2d4288b232f2df3c1db889", "instrument_name": "SCARED English (adult)", "file_name": "SCARED English (adult).pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "When I feel frightened, it is hard for me to breathe", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "I get headaches when I am at school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "I don’t like to be with people I don’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "I get scared if I sleep away from home", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "I worry about other people liking me", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "When I get frightened, I feel like passing out", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "I am nervous", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "I follow my mother or father wherever they go", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "People tell me that I look nervous", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "I feel nervous with people I don’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "My I get stomachaches at school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "When I get frightened, I feel like I am going crazy", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "13", "question_intro": None, "question_text": "I worry about sleeping alone", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "14", "question_intro": None, "question_text": "I worry about being as good as other kids", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "15", "question_intro": None, "question_text": "When I get frightened, I feel like things are not real", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "16", "question_intro": None, "question_text": "I have nightmares about something bad happening to my parents", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "17", "question_intro": None, "question_text": "I worry about going to school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "18", "question_intro": None, "question_text": "When I get frightened, my heart beats fast", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "19", "question_intro": None, "question_text": "I get shaky", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "20", "question_intro": None, "question_text": "I have nightmares about something bad happening to me", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "21", "question_intro": None, "question_text": "I worry about things working out for me", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "22", "question_intro": None, "question_text": "When I get frightened, I sweat a lot", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "23", "question_intro": None, "question_text": "I am a worrier", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "24", "question_intro": None, "question_text": "I get really frightened for no reason at all", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "25", "question_intro": None, "question_text": "I am afraid to be alone in the house", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "26", "question_intro": None, "question_text": "It is hard for me to talk with people I don’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "27", "question_intro": None, "question_text": "When I get frightened, I feel like I am choking", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "28", "question_intro": None, "question_text": "People tell me that I worry too much", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "29", "question_intro": None, "question_text": "I don’t like to be away from my family", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "30", "question_intro": None, "question_text": "I am afraid of having anxiety (or panic) attacks", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "31", "question_intro": None, "question_text": "I worry that something bad might happen to my parents", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "32", "question_intro": None, "question_text": "I feel shy with people I don’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "33", "question_intro": None, "question_text": "I worry about what is going to happen in the future", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "34", "question_intro": None, "question_text": "When I get frightened, I feel like throwing up", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "35", "question_intro": None, "question_text": "I worry about how well I do things", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "36", "question_intro": None, "question_text": "I am scared to go to school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "37", "question_intro": None, "question_text": "I worry about things that have already happened", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "38", "question_intro": None, "question_text": "When I get frightened, I feel dizzy", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "39", "question_intro": None, "question_text": "I feel nervous when I am with other children or adults and I have to do something while they watch me (for example: read aloud, speak, play a game, play a sport)", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "40", "question_intro": None, "question_text": "I feel nervous when I am going to parties, dances, or any place where there will be people that I don’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "41", "question_intro": None, "question_text": "I am shy", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "2643b44e8bb94556b37cab134e5c0afe", "instrument_id": "a2ebc5ef638e46cd94ad1d99fbfdaeae", "instrument_name": "SCARED English (child)", "file_name": "SCARED English (child).pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "When my child feels frightened, it is hard for him/her to breathe", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "My child gets headaches when he/she is at school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "My child doesn’t like to be with people he/she doesn’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "My child gets scared if he/she sleeps away from home", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "My child worries about other people liking him/her", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "When my child gets frightened, he/she feels like passing out", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "My child is nervous", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "My child follows me wherever I go", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "People tell me that my child looks nervous", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "My child feels nervous with people he/she doesn’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "My child gets stomachaches at school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "When my child gets frightened, he/she feels like he/she is going crazy", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "13", "question_intro": None, "question_text": "My child worries about sleeping alone", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "14", "question_intro": None, "question_text": "My child worries about being as good as other kids", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "15", "question_intro": None, "question_text": "When he/she gets frightened, he/she feels like things are not real", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "16", "question_intro": None, "question_text": "My child has nightmares about something bad happening to his/her parents", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "17", "question_intro": None, "question_text": "My child worries about going to school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "18", "question_intro": None, "question_text": "When my child gets frightened, his/her heart beats fast", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "19", "question_intro": None, "question_text": "He/she gets shaky", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "20", "question_intro": None, "question_text": "My child has nightmares about something bad happening to him/her", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "21", "question_intro": None, "question_text": "My child worries about things working out for him/her", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "22", "question_intro": None, "question_text": "When my child gets frightened, he/she sweats a lot", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "23", "question_intro": None, "question_text": "My child is a worrier", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "24", "question_intro": None, "question_text": "My child gets really frightened for no reason at all", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "25", "question_intro": None, "question_text": "My child is afraid to be alone in the house", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "26", "question_intro": None, "question_text": "It is hard for my child to talk with people he/she doesn’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "27", "question_intro": None, "question_text": "When my child gets frightened, he/she feels like he/she is choking", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "28", "question_intro": None, "question_text": "People tell me that my child worries too much", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "29", "question_intro": None, "question_text": "My child doesn’t like to be away from his/her family", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "30", "question_intro": None, "question_text": "My child is afraid of having anxiety (or panic) attacks", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "31", "question_intro": None, "question_text": "My child worries that something bad might happen to his/her parents", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "32", "question_intro": None, "question_text": "My child feels shy with people he/she doesn’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "33", "question_intro": None, "question_text": "My child worries about what is going to happen in the future", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "34", "question_intro": None, "question_text": "When my child gets frightened, he/she feels like throwing up", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "35", "question_intro": None, "question_text": "My child worries about how well he/she does things", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "36", "question_intro": None, "question_text": "My child is scared to go to school", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "37", "question_intro": None, "question_text": "My child worries about things that have already happened", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "38", "question_intro": None, "question_text": "When my child gets frightened, he/she feels dizzy", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "39", "question_intro": None, "question_text": "My child feels nervous when he/she is with other children or adults and he/she has to do something while they watch him/her (for example: read aloud, speak, play a game, play a sport)", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "40", "question_intro": None, "question_text": "My child feels nervous when he/she is going to parties, dances, or any place where there will be people that he/she doesn’t know well", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "41", "question_intro": None, "question_text": "My child is shy", "options": ["Not True or Hardly Ever True", "Somewhat True or Sometimes True", "Very True or Often True"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "f282674990eb42f8aff58c866802a525", "instrument_id": "632e1ff4243a4f9187ab7782d87327ac", "instrument_name": "GAD-7 Portuguese", "file_name": "GAD-7 Portuguese.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Sentir-se nervoso/a, ansioso/a ou muito tenso/a", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Não ser capaz de impedir ou de controlar as preocupações", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Preocupar-se muito com diversas coisas", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Dificuldade para relaxar", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Ficar tão agitado/a que se torna difícil permanecer sentado/a", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Ficar facilmente aborrecido/a ou irritado/a", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Sentir medo como se algo horrível fosse acontecer", "options": ["Nenhuma vez", "Vários dias", "Mais da metade dos dias", "Quase todos os dias"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "7fa20ad55769435d850b7d9a22af4c65", "instrument_id": "c566755f291e463ea3ac6f36008f94fb", "instrument_name": "De Jong Gierveld Loneliness Scale English", "file_name": "De Jong Gierveld Loneliness Scale English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "There is always someone I can talk to about my day-to-day problems", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "I miss having a really close friend", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "I experience a general sense of emptiness", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "There are plenty of people I can lean on when I have problems", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "I miss the pleasure of the company of others", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "I find my circle of friends and acquaintances too limited", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "There are many people I can trust completely", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "There are enough people I feel close to", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "I miss having people around me", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "I often feel rejected", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "I can call on my friends whenever I need them", "options": ["None of the time", "Rarely", "Some of the time", "Often", "All of the time"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "a4ba7d68beda4a7f8ffe05ea943b1b4d", "instrument_id": "ed8cfa63caef44bfb2ea9e9fcae39cdf", "instrument_name": "Market research survey fictional soft drink English", "file_name": "Market research survey fictional soft drink English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Age", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Do you drink soft drinks?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Do you like to drink BRAND?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "How often do you drink BRAND per month?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Which kinds of BRAND products have you tried?", "options": ["Standard", "Diet", "Low Sugar", "Cherry"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "What are the attractive features of BRAND?", "options": ["Price", "Image", "Packaging", "Convenience", "Taste", "Health"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Will you focus on BRAND’s new products?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "Will you buy BRAND under the following promotion?", "options": ["Definitely not", "Unlikely", "Possibly", "Probably", "Definitely"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "What do you think about the BRAND logo?", "options": ["Strongly dislike", "Somewhat dislike", "Indifferent", "Somewhat like", "Strongly like"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "What do you think about BRAND’s advertising?", "options": ["Strongly dislike", "Somewhat dislike", "Indifferent", "Somewhat like", "Strongly like"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "What do you think about BRAND’s packaging?", "options": ["Strongly dislike", "Somewhat dislike", "Indifferent", "Somewhat like", "Strongly like"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "Would you buy BRAND at X price?", "options": ["Definitely not", "Unlikely", "Possibly", "Probably", "Definitely"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "86930bbe63cb4ede8cc4a44524a08542", "instrument_id": "1d4a9907b3f34ba3962f3352c2b97654", "instrument_name": "GAD-7 English", "file_name": "GAD-7 English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1.0", "question_intro": None, "question_text": "Feeling nervous, anxious, or on edge", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2.0", "question_intro": None, "question_text": "Not being able to stop or control worrying", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3.0", "question_intro": None, "question_text": "Worrying too much about different things", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4.0", "question_intro": None, "question_text": "Trouble relaxing", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5.0", "question_intro": None, "question_text": "Being so restless that it is hard to sit still", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6.0", "question_intro": None, "question_text": "Becoming easily annoyed or irritable", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7.0", "question_intro": None, "question_text": "Feeling afraid, as if something awful might happen", "options": ["not at all", "several days", "more than half the days", "nearly every day"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": None, "question_intro": None, "question_text": "If you checked any problems, how difficult have they made it for you to do your work, take care of things at home, or get along with other people?", "options": ["Not difficult at all", "difficult", "Very difficult", "Extremely difficult"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "f5c363e5b38c4a5186387e6995e93785", "instrument_id": "fca30d7445b54f4792e312c5dc3e1909", "instrument_name": "GHQ 12 English", "file_name": "GHQ 12 English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Been able to concentrate on what you’re doing? ", "options": ["Better than usual", "Same as usual", "Less than usual", "Much less than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Lost much sleep over worry?", "options": ["Not at all", "No more than usual", "Rather more than usual", "Much more than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Felt you were playing a useful part in things?", "options": ["More so than usual", "Same as usual", "Less useful than usual", "Much less useful"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Felt capable of making decisions about things?", "options": ["More so than usual", "Same as usual", "Less so than usual", "Much less capable"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Felt constantly under strain?", "options": ["Not at all", "No more than usual", "Rather more than usual", "Much more than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Felt you couldn’t overcome your difficulties?", "options": ["More so than usual", "Same as usual", "Less so than usual", "Much less than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Been able to enjoy your normal day-to-day activities?", "options": ["Better than usual", "Same as usual", "Less than usual", "Much less than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "Been able to face up to your problems?", "options": ["More so than usual", "Same as usual", "Less so than usual", "Much less able"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "Been feeling unhappy and depressed?", "options": ["Not at all", "No more than usual", "Rather more than usual", "Much more than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "Been losing confidence in yourself?", "options": ["Not at all", "No more than usual", "Rather more than usual", "Much more than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "Been thinking of yourself as a worthless person?", "options": ["Not at all", "No more than usual", "Rather more than usual", "Much more than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "Been feeling reasonably happy, all things considered", "options": ["Better than usual", "Same as usual", "Less than usual", "Much less than usual"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "23511f8fa7104ed4a11409fc34377a7c", "instrument_id": "dcbf27b8f0f8405f8deaa4ffa707501d", "instrument_name": "Market research survey template English", "file_name": "Market research survey template English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "How much do you value the following brands?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Where have you seen the adverts for the following products?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "How much are you worried by these topics?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "How much do you like the idea of this product?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "How much does this packaging match the brand?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "How easy is it for you to understand the purpose of this product?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "How likely are you to buy this product at the advertised price?", "options": ["1", "2", "3", "4", "5"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "8d6e0f881bf9482080727ffb470b02c0", "instrument_id": "ae33a1cf29f94ef281f182fe44505abe", "instrument_name": "Adult ADHD Self-Report Scale English", "file_name": "Adult ADHD Self-Report Scale English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "How often do you have trouble wrapping up the final details of a project, once the challenging parts have been done?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "How often do you have difficulty getting things in order when you have to do a task that requires organization?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "How often do you have problems remembering appointments or obligations?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "When you have a task that requires a lot of thought, how often do you avoid or delay getting started?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "How often do you fidget or squirm with your hands or feet when you have to sit down for a long time?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "How often do you feel overly active and compelled to do things, like you were driven by a motor?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "How often do you make careless mistakes when you have to work on a boring or difficult project?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "How often do you have difficulty keeping your attention when you are doing boring or repetitive work?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "How often do you have difficulty concentrating on what people say to you, even when they are speaking to you directly?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "How often do you misplace or have difficulty finding things at home or at work?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "How often are you distracted by activity or noise around you?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "How often do you leave your seat in meetings or other situations in which you are expected to remain seated?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "13", "question_intro": None, "question_text": "How often do you feel restless or fidgety?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "14", "question_intro": None, "question_text": "How often do you have difficulty unwinding and relaxing when you have time to yourself?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "15", "question_intro": None, "question_text": "How often do you find yourself talking too much when you are in social situations?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "16", "question_intro": None, "question_text": "When you’re in a conversation, how often do you find yourself finishing the sentences of the people you are talking to, before they can finish them themselves?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "17", "question_intro": None, "question_text": "How often do you have difficulty waiting your turn in situations when turn taking is required?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "18", "question_intro": None, "question_text": "How often do you interrupt others when they are busy?", "options": ["Never", "Rarely", "Sometimes", "Often", "Very Often"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "dc81ab545fa94e8aa81eea3c76c63f4f", "instrument_id": "2ab1194b5c8e4f3c9c440167adc307bb", "instrument_name": "MacLean Screening Instrument for BPD English", "file_name": "MacLean Screening Instrument for BPD English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Have any of your closest relationships been troubled by a lot of arguments or repeated breakups?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Have you deliberately hurt yourself physically (e.g., punched yourself, cut yourself, burned yourself)? How about made a suicide attempt?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Have you had at least two other problems with impulsivity (e.g., eating binges and spending sprees, drinking too much and verbal outbursts)?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Have you been extremely moody?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Have you felt very angry a lot of the time? How about often acted in an angry or sarcastic manner?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Have you often been distrustful of other people?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Have you frequently felt unreal or as if things around you were unreal?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "Have you chronically felt empty?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "Have you often felt that you had no idea of who you are or that you have no identity?", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "Have you made desperate efforts to avoid feeling abandoned or being abandoned (e.g., repeatedly called someone to reassure yourself that he or she still cared, begged them not to leave you, clung to them physically)? ", "options": ["Yes", "No"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "70dd71b119f2449fb1587d3bafed32c2", "instrument_id": "c412a67710e84666b30855056164429f", "instrument_name": "RCADS Child Reported English", "file_name": "RCADS Child Reported English.pdf", "file_type": "pdf", "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "I worry about things", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "I feel sad or empty", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "When I have a problem, I get a funny feeling in my stomach", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "I worry when I think I have done poorly at something", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "I would feel afraid of being on my own at home", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Nothing is much fun anymore", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "I feel scared when I have to take a test", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "8", "question_intro": None, "question_text": "I feel worried when I think someone is angry with me", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "9", "question_intro": None, "question_text": "I worry about being away from my parent", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "10", "question_intro": None, "question_text": "I am bothered by bad or silly thoughts or pictures in my mind", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "11", "question_intro": None, "question_text": "I have trouble sleeping", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "12", "question_intro": None, "question_text": "I worry that I will do badly at my school work", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "13", "question_intro": None, "question_text": "I worry that something awful will happen to someone in my family", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "14", "question_intro": None, "question_text": "I suddenly feel as if I can’t breathe when there is no reason for this", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "15", "question_intro": None, "question_text": "I have problems with my appetite", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "16", "question_intro": None, "question_text": "I have to keep checking that I have done things right (like the switch is off, or the door is locked)", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "17", "question_intro": None, "question_text": "I feel scared if I have to sleep on my own", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "18", "question_intro": None, "question_text": "I have trouble going to school in the mornings because I feel nervous or afraid", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "19", "question_intro": None, "question_text": "I have no energy for things", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "20", "question_intro": None, "question_text": "I worry I might look foolish", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "21", "question_intro": None, "question_text": "I am tired a lot", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "22", "question_intro": None, "question_text": "I worry that bad things will happen to me", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "23", "question_intro": None, "question_text": "I can’t seem to get bad or silly thoughts out of my head", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "24", "question_intro": None, "question_text": "When I have a problem, my heart beats really fast", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "25", "question_intro": None, "question_text": "I cannot think clearly", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "26", "question_intro": None, "question_text": "I suddenly start to tremble or shake when there is no reason for this", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "27", "question_intro": None, "question_text": "I worry that something bad will happen to me", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "28", "question_intro": None, "question_text": "When I have a problem, I feel shaky", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "29", "question_intro": None, "question_text": "I feel worthless", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "30", "question_intro": None, "question_text": "I worry about making mistakes", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "31", "question_intro": None, "question_text": "I have to think of special thoughts (like numbers or words) to stop bad things from happening", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "32", "question_intro": None, "question_text": "I worry what other people think of me", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "33", "question_intro": None, "question_text": "I am afraid of being in crowded places (like shopping centers, the movies, buses, busy playgrounds)", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "34", "question_intro": None, "question_text": "All of a sudden I feel really scared for no reason at all", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "35", "question_intro": None, "question_text": "I worry about what is going to happen", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "36", "question_intro": None, "question_text": "I suddenly become dizzy or faint when there is no reason for this", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "37", "question_intro": None, "question_text": "I think about death", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "38", "question_intro": None, "question_text": "I feel afraid if I have to talk in front of my class", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "39", "question_intro": None, "question_text": "My heart suddenly starts to beat too quickly for no reason", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "40", "question_intro": None, "question_text": "I feel like I don’t want to move", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "41", "question_intro": None, "question_text": "I worry that I will suddenly get a scared feeling when there is nothing to be afraid of", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "42", "question_intro": None, "question_text": "I have to do some things over and over again (like washing my hands, cleaning or putting things in a certain order)", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "43", "question_intro": None, "question_text": "I feel afraid that I will make a fool of myself in front of people", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "44", "question_intro": None, "question_text": "I have to do some things in just the right way to stop bad things from happening", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "45", "question_intro": None, "question_text": "I worry when I go to bed at night", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "46", "question_intro": None, "question_text": "I would feel scared if I had to stay away from home overnight", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "47", "question_intro": None, "question_text": "I feel restless", "options": ["Never", "Sometimes", "Often", "Always"], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "9cda1d82cd864aa990505c9ff53c28f3", "instrument_id": "a9aa9ab93b5a4b2f818ab0885756711a", "instrument_name": "GAD-7 French", "file_name": "GAD-7 French.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Sentiment de nervosité, d’anxiété ou de tension", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Incapable d’arrêter de vous inquiéter ou de contrôler vos inquiétudes", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Inquiétudes excessives à propos de tout et de rien", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Difficulté à se détendre", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Agitation telle qu’il est difficile de rester tranquille", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Devenir facilement contrarié(e) ou irritable", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Avoir peur que quelque chose d’épouvantable puisse arriver", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "6adfa91ac468471a983f176306a3207e", "instrument_id": "6d1531be4b4e42b2a4dbceb56cb3e1fb", "instrument_name": "GAD-7 German", "file_name": "GAD-7 German.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Nervosität, Ängstlichkeit oder Anspannung", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Nicht in der Lage sein, Sorgen zu stoppen oder zu kontrollieren", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Übermäßige Sorgen bezüglich verschiedener Angelegenheiten", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Schwierigkeiten zu entspannen", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Rastlosigkeit, so dass Stillsitzen schwer fällt", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Schnelle Verärgerung oder Gereiztheit", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Gefühl der Angst, so als würde etwas Schlimmes passieren", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "112e61fcff274da6ae45b9915d419e6a", "instrument_id": "24629d5132a641af9ba53d76336c8d59", "instrument_name": "GAD-7 Spanish", "file_name": "GAD-7 Spanish.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Sentirse nervioso/a, intranquilo/a o con los nervios de punta", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "No poder dejar de preocuparse o no poder controlar la preocupación", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Preocuparse demasiado por diferentes cosas", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Dificultad para relajarse", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Estar tan inquieto/a que es difícil permanecer sentado/a tranquilamente", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Molestarse o ponerse irritable fácilmente", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Sentir miedo como si algo terrible pudiera pasar", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "ef13800310b041b5804b81bf385fd274", "instrument_id": "31f343f78ee8427b8f3c6729a4969874", "instrument_name": "GAD-7 Russian", "file_name": "GAD-7 Russian.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Вы нервничали, тревожились или испытывали сильный стресс", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Вы были неспособны успокоиться или контролировать свое волнение", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Вы слишком сильно волновались по различным поводам", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Вам было трудно расслабиться", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Вы были настолько суетливы, что Вам было тяжело усидеть на месте", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Вы легко злились или раздражались", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Вы испытывали страх, словно должно произойти нечто ужасное", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "18bb8871590440e392f4412e58476b5c", "instrument_id": "a803754c5eef453682b0221279d52e80", "instrument_name": "GAD-7 Chinese", "file_name": "GAD-7 Chinese.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "感觉紧张、焦虑或不安", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "无法停止或控制担忧", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "对各种事情担心太多 ", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "难以放松 ", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "坐立不安，以至于很难安静地坐下来", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "变得容易生气或急躁 ", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "感觉害怕，好像有可怕的事情要发生一样", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "45c8717368c44a4a8227a54ac4a5ff4a", "instrument_id": "eff6a5df7b3b4391b701adcd1dc95c30", "instrument_name": "GAD-7 Afrikaans", "file_name": "GAD-7 Afrikaans.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Senuagtig, angstig of gespanne gevoel", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Kon nie ophou om bekommerd te wees nie", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Oormatig bekommerd oor verskillende goed", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Sukkel om te ontspan", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Só rusteloos dat dit moeilik is om stil te sit", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Raak maklik vies of geïrriteerd", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Voel bang asof iets aakligs kan gebeur ", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "922e39f3a0ef44b98b76c860ed0e86a9", "instrument_id": "de5d1e09af484aba9f58b824e00fc691", "instrument_name": "GAD-7 Cebuano", "file_name": "GAD-7 Cebuano.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Gibati og nerbiyos, kabalaka, o kahadlok", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Dili makahunong o makakontrol sa pagkabalaka", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Sobra nga nabalaka bahin sa lain-lain nga mga butang", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Lisod pagkalma", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Nag-alindasay pag-ayo nga lisod pagpabilin nga maglingkod", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Nahimong dali maglagot o iritable", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Nahadlok nga basin naay dautan nga mahitabo ", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "7942abf019dd43ef9435f357bb9bd258", "instrument_id": "37f2fc5847b44439a122dc32e69ebcaa", "instrument_name": "GAD-7 Kannada", "file_name": "GAD-7 Kannada.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "ತಳಮಳ, ಆತಂಕ ಅಥ ಾ ಬಹಳ ΅ಾತರದ ಅನುಭವ", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "‷ಂ⁀ಸುವ⁳ದನುΊ ⁄⁌ῤಸಲು ಅಥ ಾ ⁄ಯಂ⁀ῢಸಲು ಧῡ ಾಗ⁂ರುವ⁳ದು", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "⁧ೕ⁫ ⁧ೕ⁫ ⁎ಷಯಗಳ ಬ⁕Ὴ ಅ⁀ ಾ‵ ‷ಂ⁀ಸುವ⁳ದು", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "⁄ ಾಳ ಾ‵ರಲು ⁠ೂಂದ⁫", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "ಒಂದು ಕ⁝ ⁑Ῐರ ಾ‵ ಕು⁍ತು⁓ೂಳῥಲೂ ಆಗದಷುῒ ಚಡಪ‽ಸುವ⁳ದು", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "ಸುಲಭ ಾ‵ ⁓ೂೕಪ⁕ೂಳುῥವ⁳ದು ಅಥ ಾ ″⁋″⁋ ಾಗುವ⁳ದು", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "ಏ῿ಾದರೂ ಅ῿ಾಹುತ ಸಂಭ⁎ಸುತῗ⁢ ಎಂದು ⁲ದರುವ⁳ದು", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "266ab87970b54d20ae274586ef353378", "instrument_id": "10c21c991bbe4887a90953670f04394c", "instrument_name": "GAD-7 Hebrew", "file_name": "GAD-7 Hebrew.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "הרגשתי עצבני, חרד או מתוח מאוד", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "לא הייתי מסוגל להפסיק לדאוג או לשלוט בדאגה", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "הייתי מודאג יותר מידי בנוגע לדברים שונים", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "התקשיתי להירגע", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "הייתי כל כך חסר מנוחה שהיה לי קשה לשבת מבלי לנוע", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "הייתי מתעצבן או מתרגז בקלות", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "פחדתי כאילו משהו נורא עלול לקרות", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
{"file_id": "ecdfd265f8f540e194038706561cc3b1", "instrument_id": "994f4dbb04af4aedb139f1100728a400", "instrument_name": "GAD-7 Norwegian", "file_name": "GAD-7 Norwegian.pdf", "file_type": None, "file_section": None, "study": None, "sweep": None, "metadata": None, "language": "en", "questions": [{"question_no": "1", "question_intro": None, "question_text": "Følt deg nervøs, engstelig eller veldig stresset", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "2", "question_intro": None, "question_text": "Ikke klart å slutte å bekymre deg eller kontrolleren bekymringene dine", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "3", "question_intro": None, "question_text": "Bekymret deg for mye om ulike ting", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "4", "question_intro": None, "question_text": "Vansker med å slappe av", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "5", "question_intro": None, "question_text": "Vært så rastløs at det har vært vanskelig å sitte stille", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "6", "question_intro": None, "question_text": "Blitt lett sint eller irritert", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}, {"question_no": "7", "question_intro": None, "question_text": "Følt deg redd som om noe forferdelig kunne komme til å skje", "options": [], "source_page": 0, "instrument_id": None, "instrument_name": None, "topics_auto": None, "nearest_match_from_mhc_auto": None}]},
]])